(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.multimania.com/haypo/ $$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
    Dmonstration montrant l'utilisation possible de l'unit SClavier.      
Ĵ
  Fichiers ncessaires                                                    
                                                    
                                                                            
 -> 'ClavInt.Pcx' : Image de fond                                           
*)

{$M 4096,0,1000}

uses EcranVga,FaitPaus,PalVideo,Pcx,SClavier;

const
  Off_On: array[0..1] of string[3] = ('off','ON ');

  { Couleur }
  Noir  = 0;
  Blanc = 254;
  CoulFond = 255;
  CoulPause = 100;

  { Positions }
  ScanX = 13*8; ScanY = 160;  { Positions du texte sur les scans codes }
  MajX = 14*8;  MajY  = 110;  { Positions du texte sur l'tat majuscule, ... }
  ChrX  = 20*8;               { X du caractre ASCII }
  EtatX = 7*8;                { X de l'tat de la touche }
  DefX  = 3*8;                { X de la dfinition }

var
  Palette: Array[0..255] of RVB;
  i: byte;
  ch: char;
  txt: string;

procedure ActuTouche (Ascii: char); begin with Clavier do begin
  AttendEcran;

  { Ecrit le caractre ASCII }
  if ascii<>#0 then begin
    str (ord(ascii):3,txt);
    EcriVga (ScanX,ScanY+1*8, txt,   Blanc,CoulFond);
    EcriVga (ChrX, ScanY+1*8, ascii, Blanc,CoulFond);
  end else begin
    EcriVga (ScanX,ScanY+1*8,'???',Blanc,CoulFond);
    EcriVga (ChrX, ScanY+1*8,' ',  Blanc,CoulFond);
  end;
end end;

procedure Init; begin
  { Initialise l'cran }
  ModeVga256;                                 { Mode 320*200 en 256 couleurs }
  AffichePcx (0,0,'ClavInt.pcx');                            { Image de fond }

  { Ecrit du texte }
  EcriTsp (0,MajY+8*0,'Majuscule   : ON',Blanc);
  EcriTsp (0,MajY+8*1,'Verrouille  : ON',Blanc);
  EcriTsp (0,MajY+8*2,'Arrt dfil : ON',Blanc);
  EcriTsp (0,MajY+8*3,'Insertion   : ON',Blanc);

  EcriTsp (0,ScanY+8*1,'Code ASCII = ??? - "?"',Blanc);
  EcriTsp (0,ScanY+8*3,'->'                      ,Blanc);
  EcriTsp (DefX,ScanY+8*3,'Pressez une touche', Noir);

  { Installe mon driver Clavier }
  InitClavier;
end;

procedure Fin; begin
  ModeTxt;
  FinClavier;
end;

begin
  Init;

  repeat
    { Actualise la palette }
    for i := 1 to 223 do with Palette[i] do begin
      if i=CoulPause then
        if Clavier.Touche[_ScanPause] then begin
          R := 63; B := 63; V := 63;
        end else begin
          R := 63; B := 0; V := 63;
        end
      else
        if Clavier.Touche[i] then begin
          R := 0; B := 0; V := 63;
        end else begin
          R := 63; B := 0; V := 0;
        end;
    end;

    { Change toute la palette }
    AttendEcran;
    ChangeGrandePal (Palette[1],1,223-1);

    { Affiche l'tat des touches drapeaux }
    with Clavier do begin
      EcriVga (MajX,MajY+0*8, Off_On[ord(maj)], 254-ord(maj), CoulFond);
      EcriVga (MajX,MajY+1*8, Off_On[ord(Ver)], 254-ord(Ver), CoulFond);
      EcriVga (MajX,MajY+2*8, Off_On[ord(Arr)], 254-ord(Arr), CoulFond);
      EcriVga (MajX,MajY+3*8, Off_On[ord(Ins)], 254-ord(Ins), CoulFond);
    end;

    { Le tampon est plein ? }
    if Clavier.Deborde then begin
      EcriVga (-1,-1,'TAMPON PLEIN',blanc,noir);

      repeat until (not Clavier.Deborde);

      EcriVga (-1,-1,'            ',blanc,CoulFond);
    end;

    { Si une touche est presse, l'actualise }
    if TouchPresse then ActuTouche (LitTouche);
  until Clavier.Touche[_ScanEchape];

  Fin;
end.